//+------------------------------------------------------------------+
//|                                                  mt_terminal.mq4 |
//|                                           Copyright  2011, albr |
//|                                                     albr@ukr.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, albr"
#property link      "albr@ukr.net"
#include <stderror.mqh>
#include <stdlib.mqh>

extern bool ShowArrow4NewOrders = false; //    // 
extern int order_slippage = 3; //     

int magicnumber = 123; //      

/*   ( ) */
string g_last_error_message = ""; //   ,   
int g_accMaxLotSize = 0; //  -  .   .     .
double g_accMaxLotValue = 0; //     .   .     .
int g_currentLotSize = 0; //  -  .
double g_currentLotValue = 0; //     .
string g_set_curr = ""; //  

#import "mt_dll.dll"
   int init_dll(); 
   int deinit_dll();
   int prepare_write_dll();
   int write_dll(string);
   int commit_dll();   
   int get_orders_count_dll();
   string get_order_dll(int);
#import


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{  
  init_dll();
  return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  deinit_dll();
  return(0);
}
/*
aOrder:  OO LLLLL TTTTTTTTTT SSSSSSSSSSSSSSS PPPPPPPPPPPPPPP CCCCCCCC
         01 23456 7890123456 789012345678901 234567890123456 78901234
         

O 02[00 .. 01]: BN - buy now; SN - sell now; CN - Close now; BL - Buy Limit; BS - Buy Stop; SL - Sell Limit; SS - Sell Stop; CO - cancel order; MO - Modify Order;
                LS - max lots size; LV - max lots value;
L 05[02 .. 06]: lot size 5,2;
T 10[07 .. 16]: ticket no
S 15[17 .. 31]: stop lose 15
                max lot size; max lot value 
P 15[32 .. 46]: take profit 15
C 8 [47 .. 54]: currency
*/
int ParseOrder (string aOrder, int& aOrderType, double& aOrderValue, int& aOrderTicket, int& aOrderTP, int& aOrderSL, string& aCurrency)
{ 
  
  if (aOrder == "RESET_ERROR") 
  {
    g_last_error_message = ""; 
    return (1);
  }
  if (StringLen(aOrder)  < 7) return (1);
  
  int res = 0;
  
  string ordType = StringSubstr(aOrder, 0, 2);
  
  if (ordType == "BN")
  { 
    aOrderType = OP_BUY;
    aOrderValue = StrToDouble(StringTrimRight(StringSubstr(aOrder, 2, 5)))/100;    
    
    aOrderSL = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));    
    aOrderTP = StrToInteger(StringTrimRight(StringSubstr(aOrder, 32, 15))); 
    aCurrency = StringTrimRight(StringSubstr(aOrder, 47, 8));
    
  } else

  if (ordType == "SN")
  {
    aOrderType = OP_SELL;
    aOrderValue = StrToDouble(StringTrimRight(StringSubstr(aOrder, 2, 5)))/100;

    aOrderSL = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));    
    aOrderTP = StrToInteger(StringTrimRight(StringSubstr(aOrder, 32, 15)));        
    aCurrency = StringTrimRight(StringSubstr(aOrder, 47, 8));
  } else
  
  if (ordType == "CO")
  {
    aOrderType = -1;
    aOrderTicket = StrToInteger(StringTrimLeft(StringSubstr(aOrder, 7, 10)));
  } else
 
  if (ordType == "LS")
  {    //  -  .   .     .
    g_accMaxLotSize = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));
   
    res = 1;
  } else    
  
  if (ordType == "LV")
  {    //     .   .     .
    g_accMaxLotValue = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));        
    g_accMaxLotValue = g_accMaxLotValue / 100;
    res = 1;
  } else    
  
  if (ordType == "SC")
  {    // Set Currency
    g_set_curr = StringTrimRight(StringSubstr(aOrder, 7, 10));
    if (MarketInfo(g_set_curr, MODE_ASK) == 0) {g_set_curr = "";}
    
    res = 1;
  } else    
  
  {
    res = 1;
  }
  return (res);
}

/* getCurrency -  */
string getCurrency(string aCCY)
{
  if (aCCY != "") {return (aCCY);}
  if (g_set_curr == "") {return (Symbol());}
  return (g_set_curr);  
}

double getCurrencyBid(string aCCY)
{
  return (MarketInfo(getCurrency(aCCY), MODE_BID));
}

double getCurrencyAsk(string aCCY)
{
  return (MarketInfo(getCurrency(aCCY), MODE_ASK));
}

double getCurrencyPoint(string aCCY)
{
  return (MarketInfo(getCurrency(aCCY), MODE_POINT));
}



/*CheckOrder -     - 
  albr
*/
bool CheckOrder(int aOrderType, double aOrderValue, string& aMess)
{

  if (g_accMaxLotSize > 0) 
  {
    if  (g_currentLotSize+1 > g_accMaxLotSize) 
    {
      if (aMess != "") aMess = aMess + ";%%%";
      aMess = "[" + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS ) + "]     -  .  = "+g_accMaxLotSize+".  - = "+g_currentLotSize;
      return (false);
    }
  }
  
  if (g_accMaxLotValue > 0) 
  {
    if  (g_currentLotValue+aOrderValue > g_accMaxLotValue) 
    {
      if (aMess != "") aMess = aMess + ";%%%";
      aMess = "[" + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS ) + "]       .  = "+DoubleToStr(NormalizeDouble(g_accMaxLotValue ,2),2)
              +".   = "+DoubleToStr(NormalizeDouble(g_currentLotValue,2),2);
      return (false);
    }
  }

  return (true);
}

/* apply_new_orders -   
  albr
*/
int apply_new_orders(string acc_num)
{
  int new_orders = get_orders_count_dll();
  int ticket = 0;
  
  string lOrder;    
  if (new_orders > 0)
  {
    for (int i = 0; i<new_orders; i++)
    {
      RefreshRates();
      lOrder = get_order_dll(i);  
      
      int lOrderType; 
      double lOrderValue; 
      int lOrderTP;
      int lOrderSL;
      double lOrderTP_;
      double lOrderSL_;      
      int lOrderTicket;
      int lColorB = Green;
      int lColorS = Violet;
      string lCCY = "";
      string sOrd = "";
      
      if (ShowArrow4NewOrders == false)
      {
        lColorB = CLR_NONE;
        lColorS = CLR_NONE;
      }
      
      if (ParseOrder (lOrder, lOrderType, lOrderValue, lOrderTicket, lOrderTP, lOrderSL, lCCY) == 0)
      {       
        
        if (lOrderType == OP_BUY && lOrderValue > 0) 
        {  
          if (CheckOrder(lOrderType, lOrderValue, g_last_error_message) == false) return (0);
          
          if (lOrderTP <= 0) 
            {lOrderTP_ = NULL;} else
            {lOrderTP_ = getCurrencyAsk(lCCY) + lOrderTP*getCurrencyPoint(lCCY);}
            
          if (lOrderSL <= 0) 
            {lOrderSL_ = NULL;} else
            {lOrderSL_ = getCurrencyAsk(lCCY) - lOrderSL*getCurrencyPoint(lCCY);}    
        
          ticket = OrderSend(getCurrency(lCCY), OP_BUY, lOrderValue, getCurrencyAsk(lCCY), order_slippage, lOrderSL_, lOrderTP_, NULL, magicnumber, 0, lColorB);
          sOrd = DoubleToStr(NormalizeDouble(lOrderValue ,2),2) + " BUY (#"+ticket+") "+getCurrency(lCCY);
        }
        else 
        if (lOrderType == OP_SELL && lOrderValue > 0) 
        {
          if (CheckOrder(lOrderType, lOrderValue, g_last_error_message) == false) return (0);
          
          if (lOrderTP <= 0) 
            {lOrderTP_ = NULL;} else
            {lOrderTP_ = getCurrencyBid(lCCY) - lOrderTP*getCurrencyPoint(lCCY);}
            
          if (lOrderSL <= 0) 
            {lOrderSL_ = NULL;} else
            {lOrderSL_ = getCurrencyBid(lCCY) + lOrderSL*getCurrencyPoint(lCCY);}    

          ticket = OrderSend(getCurrency(lCCY), OP_SELL, lOrderValue, getCurrencyBid(lCCY), order_slippage, lOrderSL_, lOrderTP_, NULL, magicnumber, 0, lColorB);
          sOrd = DoubleToStr(NormalizeDouble(lOrderValue ,2),2) + " SELL (#"+ticket+") "+getCurrency(lCCY);
        }
        else
        if (lOrderType == -1 && lOrderTicket > 0) 
        {         
            if(OrderSelect(lOrderTicket, SELECT_BY_TICKET, MODE_TRADES)==true)
            {              
              if(OrderType()==OP_BUY) 
              {    
                sOrd = DoubleToStr(NormalizeDouble(OrderLots() ,2),2) + " CLOSE BUY (#"+lOrderTicket+") "+DoubleToStr(NormalizeDouble(OrderProfit()+OrderSwap(),2),2)+" "+OrderSymbol();
                OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),order_slippage,lColorS); 
              }
              else
              if(OrderType()==OP_SELL) 
              {
                sOrd = DoubleToStr(NormalizeDouble(OrderLots() ,2),2) + " CLOSE SELL (#"+lOrderTicket+") "+DoubleToStr(NormalizeDouble(OrderProfit()+OrderSwap(),2),2)+" "+OrderSymbol();
                OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),order_slippage,lColorS); 
              }
            }    
        }
        
        int err=GetLastError();
        if (g_last_error_message != "") g_last_error_message = g_last_error_message + ";%%%";
        
        g_last_error_message = g_last_error_message + "[" + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS ) + "] ";        
        if (err != ERR_NO_ERROR)
        {
          g_last_error_message = g_last_error_message + ErrorDescription(err);
        } 
          else
        {
          g_last_error_message = g_last_error_message + sOrd;          
         }

      }
    }
  }  
  return (0);    
}

/* upload_account_info -     
  albr
*/  
int upload_account_info(string acc_num)
{  
  prepare_write_dll();
  write_dll("[ACCOUNT]="+acc_num);    
  write_dll("[BALANCE]="+DoubleToStr(NormalizeDouble(AccountBalance(),2),2));
  write_dll("[EQUITY]="+DoubleToStr(NormalizeDouble(AccountEquity(),2),2));
  write_dll("[PROFIT]="+DoubleToStr(NormalizeDouble(AccountEquity()-AccountBalance(),2),2));
  double lpoint = getCurrencyPoint("");
  if (lpoint == 0) 
  {    
    write_dll("[SPREAD]=0"); 
    write_dll("[DEFCCYASK]=0");
    write_dll("[DEFCCYBID]=0");
  
  } else
  {
    write_dll("[SPREAD]="+DoubleToStr((getCurrencyAsk("") - getCurrencyBid(""))/lpoint,0));
    write_dll("[DEFCCYASK]="+DoubleToStr(getCurrencyAsk("")/lpoint,0));
    write_dll("[DEFCCYBID]="+DoubleToStr(getCurrencyBid("")/lpoint,0));
  }
  write_dll("[DEFCCY]="+getCurrency(""));  
  
  
  
    
  int totalorders = OrdersTotal();
  g_currentLotSize = totalorders;
  g_currentLotValue = 0; 
  
  write_dll("[ORDERS]="+DoubleToStr(NormalizeDouble(totalorders,0),0));
    
  for (int i=0; i < totalorders; i++)
  { 
    if (OrderSelect(i, SELECT_BY_POS)) 
    {
      write_dll("[ORDER_"+i+"_TICKET]="+OrderTicket()); 
      write_dll("[ORDER_"+i+"_SYMBOL]="+OrderSymbol()); 
        
      string ord_type;        
      switch(OrderType())
      {
        case OP_BUY: ord_type = "BUY"; break;
        case OP_SELL: ord_type = "SELL"; break;
        case OP_BUYLIMIT: ord_type = "BUYLIMIT"; break;
        case OP_BUYSTOP: ord_type = "BUYSTOP"; break;
        case OP_SELLLIMIT: ord_type = "SELLLIMIT"; break;
        case OP_SELLSTOP: ord_type = "SELLSTOP"; break;
      }
      write_dll("[ORDER_"+i+"_TYPE]="+ord_type);        
      write_dll("[ORDER_"+i+"_LOTS]="+DoubleToStr(NormalizeDouble(OrderLots(),2),2));
      g_currentLotValue = g_currentLotValue + OrderLots();
      write_dll("[ORDER_"+i+"_OPENTIME]="+TimeToStr(OrderOpenTime(),TIME_DATE|TIME_SECONDS));        
      write_dll("[ORDER_"+i+"_PROFIT]="+DoubleToStr(NormalizeDouble(OrderProfit(),2),2));
      write_dll("[ORDER_"+i+"_SWAP]="+DoubleToStr(NormalizeDouble(OrderSwap() ,2),2));
      write_dll("[ORDER_"+i+"_MAGIC]="+DoubleToStr(NormalizeDouble(OrderMagicNumber() ,0),0));
      
      write_dll("[ORDER_"+i+"_OPENPRICE]="+DoubleToStr(NormalizeDouble(OrderOpenPrice(), 5), 5));
      write_dll("[ORDER_"+i+"_STOPLOSS]="+DoubleToStr(NormalizeDouble(OrderStopLoss(), 5), 5));
      write_dll("[ORDER_"+i+"_TAKEPROFIT]="+DoubleToStr(NormalizeDouble(OrderTakeProfit(), 5), 5));      
      
     
      write_dll("[ORDER_"+i+"_SYMBOLBID]="+DoubleToStr(NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID), 5), 5));      
      write_dll("[ORDER_"+i+"_SYMBOLASK]="+DoubleToStr(NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK), 5), 5));      
    }
  }  
    
  if (g_last_error_message != "") 
    write_dll("[ERR_MESSAGE]="+g_last_error_message);
    
  commit_dll(); 
  
  return (0);      
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{      
  apply_new_orders(AccountNumber());
  upload_account_info(AccountNumber());  
  return(0);
}
//+------------------------------------------------------------------+